diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
index 099bee88e..be379116b 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
@@ -3,41 +3,44 @@ package net.minecraft.client.render.dynamictexture;
 import java.awt.image.BufferedImage;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.client.util.helper.Textures;
 
-public class DynamicTextureTrommel extends DynamicTextureRotating{
+public class DynamicTextureTrommel extends DynamicTextureRotating {
 	
 	private boolean counterClockwise;
 	
 	private double rotation = 0.0;
-	
 	private double speed = 0.12;
 	
 	public DynamicTextureTrommel(Minecraft minecraft, IconCoordinate textureIndex, boolean counterClockwise) {
 		super(minecraft, textureIndex);
-		
+
 		this.counterClockwise = counterClockwise;
+	}
+	
+	@Override
+	public void postInit() {
+		setTexture(texture);
+		
+		BufferedImage atlasImage = texture.parentAtlas.atlas;
 		
-		BufferedImage bufferedimage = textureIndex.parentAtlas.atlas;
-		IconCoordinate background = TextureRegistry.getTexture("minecraft:block/trommel_active_front_background");
 		IconCoordinate foreground = TextureRegistry.getTexture("minecraft:block/trommel_active_front_foreground");
-		dialImageData = new byte[textureIndex.getArea() * 4];
-		for(int x=0; x < textureIndex.width; x++) {
-			for(int y=0; y < textureIndex.height; y++) {
-				putPixel(dialImageData, y * textureIndex.width + x, bufferedimage.getRGB(foreground.iconX + x, foreground.iconY + y));
+		dialImageData = new byte[foreground.getArea() * 4];
+		for(int x=0; x < foreground.width; x++) {
+			for(int y=0; y < foreground.height; y++) {
+				putPixel(dialImageData, y * foreground.width + x, atlasImage.getRGB(foreground.iconX + x, foreground.iconY + y));
 			}
 		}
-		clockImageData = new byte[textureIndex.getArea() * 4];
-		for(int x=0; x < textureIndex.width; x++) {
-			for(int y=0; y < textureIndex.height; y++) {
-				putPixel(clockImageData, y * textureIndex.width + x, bufferedimage.getRGB(background.iconX+ x, background.iconY + y));
+		dialTexRes = foreground.width;
+		
+		IconCoordinate background = TextureRegistry.getTexture("minecraft:block/trommel_active_front_background");
+		clockImageData = new byte[background.getArea() * 4];
+		for(int x=0; x < background.width; x++) {
+			for(int y=0; y < background.height; y++) {
+				putPixel(clockImageData, y * background.width + x, atlasImage.getRGB(background.iconX+ x, background.iconY + y));
 			}
 		}
-		
-		dialTexRes = textureIndex.height;
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index 049c77706..6f60365cd 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -13,9 +13,10 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 	private float[] arr4;
 	private int ticks = 0;
 
-	public DynamicTextureWaterFlow() {
-		super(TextureRegistry.getTexture("minecraft:block/water_flowing"));
-
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/water_flowing"));
+		
 		arr1 = new float[texture.getArea()];
 		arr2 = new float[texture.getArea()];
 		arr3 = new float[texture.getArea()];
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index d40cea63a..1cf3862ec 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -12,8 +12,9 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 	private float[] arr3;
 	private float[] arr4;
 
-	public DynamicTextureWaterStill() {
-		super(TextureRegistry.getTexture("minecraft:block/water_still"));
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/water_still"));
 
 		arr1 = new float[texture.getArea()];
 		arr2 = new float[texture.getArea()];
diff --git a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
index e3bcfaddd..8f2757d95 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
@@ -19,7 +19,7 @@ public class ArmoredZombieRenderer extends MobRenderer<EntityArmoredZombie>
 
     protected boolean setArmorModel(EntityArmoredZombie zombie, int renderPass, float partialTick)
     {
-        loadTexture("/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
+        loadTexture("/assets/minecraft/textures/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
         ModelZombie model = renderPass != 2 ? modelArmorChestplate : modelArmor;
         model.bipedHead.showModel = renderPass == 0;
         model.bipedHeadOverlay.showModel = renderPass == 0;
diff --git a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java b/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
index 28abaeede..eb3137b22 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
+++ b/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
@@ -1,22 +1,27 @@
 package net.minecraft.client.render.stitcher;
 
-import net.minecraft.client.GLAllocation;
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.util.helper.Textures;
-import org.jetbrains.annotations.Nullable;
-
-import java.awt.*;
+import java.awt.AlphaComposite;
+import java.awt.Graphics2D;
 import java.awt.image.BufferedImage;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.HashMap;
+import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
+import java.util.Set;
+
+import org.jetbrains.annotations.Nullable;
+
+import net.minecraft.client.GLAllocation;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.util.helper.Textures;
 
 public class AtlasStitcher {
     private static final Minecraft mc = Minecraft.getMinecraft(AtlasStitcher.class);
     public static final String rootAssetPath = "/assets";
     public Map<String, IconCoordinate> textureMap = new HashMap<>();
+    public Set<IconCoordinate> dontSetSize = new HashSet<>();
     public BufferedImage atlas;
     public final String directoryPath;
     @Nullable
@@ -52,6 +57,9 @@ public class AtlasStitcher {
         int maxWidth = 0;
         List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
         for (IconCoordinate coordinate : coordinateList){
+        	if(dontSetSize.contains(coordinate)) {
+        		continue;
+        	}
             BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(coordinate.sourceImage));
             if (image == null || image == Textures.missingTexture){
                 System.out.println(coordinate.sourceImage + " could not be found!");
@@ -65,6 +73,7 @@ public class AtlasStitcher {
             area += coordinate.getArea();
             if (coordinate.width > maxWidth) maxWidth = coordinate.width;
         }
+        dontSetSize.clear();
         // Calculate an okay atlas width to keep the aspect ratio of the final atlas mostly 1:1
         int targetWidth = (int) (Math.max(Math.ceil(Math.sqrt(area)), maxWidth));
         Collections.sort(coordinateList);
diff --git a/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java b/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java
index c59f497f3..32bf70e6c 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java
+++ b/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java
@@ -10,7 +10,6 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     public int iconY;
     public int width;
     public int height;
-    private int area;
     protected final String sourceImage;
     public final String namespaceId;
     public final AtlasStitcher parentAtlas;
@@ -29,14 +28,13 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     public void setDimension(int width, int height){
         this.width = width;
         this.height = height;
-        this.area = width * height;
     }
     public void setPosition(int x, int y){
         this.iconX = x;
         this.iconY = y;
     }
     public int getArea(){
-        return area;
+        return width * height;
     }
     protected void drawToAtlas(Graphics2D atlas){
         atlas.drawImage(_imageStorage, iconX, iconY, null);
diff --git a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
index 0b8a59c59..958b64dd7 100644
--- a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
@@ -135,6 +135,17 @@ public class TessellatorStandard extends TessellatorBase {
 	public void addVertex(double x, double y, double z) {
 		checkIsDrawing();
 
+		if(buffer.capacity() < buffer.position() + 64) {
+			int newSize = buffer.capacity() * 2;
+			
+			System.out.println("Expanding Tessellator Buffer (" + buffer.capacity() + " -> " + newSize + ")");
+			
+			ByteBuffer newBuffer = ByteBuffer.allocateDirect(newSize).order(ByteOrder.nativeOrder());
+			this.buffer.flip();
+			newBuffer.put(buffer);
+			this.buffer = newBuffer;
+		}
+		
 		buffer.putFloat((float) (offsetX + x));
 		buffer.putFloat((float) (offsetY + y));
 		buffer.putFloat((float) (offsetZ + z));
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index a3114b2a5..24459217c 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -194,4 +194,17 @@ public class TexturePackList
 		if (selectedPacks.isEmpty()) return defaultTexturePack;
 		return selectedPacks.get(selectedPacks.size()-1);
 	}
+	
+	public TexturePack getHighestPriorityTexturePackWithFile(String path) {
+		for(int i = selectedPacks.size() - 1; i >= 0; i--) {
+			TexturePack texturePack = selectedPacks.get(i);
+			if(texturePack.hasFile(path)) {
+				return texturePack;
+			}
+		}
+		if(defaultTexturePack.hasFile(path)) {
+			return defaultTexturePack;
+		}
+		return null;
+	}
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 6c6401dd2..165d39805 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block.entity;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.IVehicle;
 
@@ -17,6 +18,11 @@ public class TileEntitySeat
         if (passenger != null) {
             worldObj.updateEntity(passenger);
         }
+
+        // TODO the server really needs a better way of telling the client that a tile entity no longer exists, but this works to fix the client thinking that the seat remains if its broken in multiplayer
+        if (worldObj.getBlock(x, y, z) != Block.seat){
+            ejectRider();
+        }
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/crafting/ICrafting.java b/src/main/java/net/minecraft/core/crafting/ICrafting.java
index 88a42602d..a686b2c74 100644
--- a/src/main/java/net/minecraft/core/crafting/ICrafting.java
+++ b/src/main/java/net/minecraft/core/crafting/ICrafting.java
@@ -10,7 +10,7 @@ import java.util.List;
 
 public interface ICrafting
 {
-    void updateCraftingInventory(Container container, List list);
+    void updateCraftingInventory(Container container, List<ItemStack> list);
 	
     void updateInventorySlot(Container container, int i, ItemStack itemstack);
 
diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index eb89adc33..f93497ea8 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -548,6 +548,10 @@ public abstract class EntityLiving extends Entity
         {
             dropFewItems();
         }
+        if (vehicle != null){
+            vehicle.ejectRider();
+            vehicle = null;
+        }
         world.sendTrackedEntityStatusUpdatePacket(this, (byte)3);
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index 2792ac683..47b9736ca 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -381,7 +381,7 @@ public class EntityWolf extends EntityAnimal
         super.tick();
 
         List<Entity> entitiesNearWolf = world.getEntitiesWithinAABBExcludingEntity(this, bb);
-        if(entitiesNearWolf != null && entitiesNearWolf.size() > 0)
+        if(entitiesNearWolf != null && entitiesNearWolf.size() > 0 && isAlive())
         {
             for (Entity entity : entitiesNearWolf) {
                 if(entity instanceof EntityItem && (this.getWolfHeldItem() == null || this.getWolfHeldItem().getItem() == null)){
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 2534592c4..74e99b3bd 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -147,6 +147,21 @@ public class EntityBoat extends Entity
         }
         return true;
     }
+    @Override
+    public void remove(){
+        Entity entity = passenger;
+
+        if (entity != null){
+            double bbCenterX = (bb.minX + bb.maxX)/2;
+            double bbCenterZ = (bb.minZ + bb.maxZ)/2;
+
+            this.passenger = null;
+            entity.vehicle = null;
+            entity.moveTo(bbCenterX, this.bb.maxY + 0.1, bbCenterZ, entity.yRot, entity.xRot);
+        }
+
+        super.remove();
+    }
 
     @Override
 	public void animateHurt()
@@ -466,8 +481,11 @@ public class EntityBoat extends Entity
     
     @Override
     public Entity ejectRider() {
-    	Entity entity = super.ejectRider();
-    	if(entity == null) return null;
+        Entity entity = passenger;
+        if(entity == null) return null;
+
+        this.passenger = null;
+        entity.vehicle = null;
 
         double bbCenterX = (bb.minX + bb.maxX)/2;
         double bbCenterY = (bb.minY + bb.maxY)/2;
@@ -488,7 +506,7 @@ public class EntityBoat extends Entity
         if (!flag){
             entity.moveTo(bbCenterX, this.bb.maxY + 0.1, bbCenterZ, entity.yRot, entity.xRot);
         }
-    	return entity;
+        return entity;
     }
     @Override
     protected void causeFallDamage(float f){}
diff --git a/src/main/java/net/minecraft/core/lang/I18n.java b/src/main/java/net/minecraft/core/lang/I18n.java
index 87548b9ca..808480f2e 100644
--- a/src/main/java/net/minecraft/core/lang/I18n.java
+++ b/src/main/java/net/minecraft/core/lang/I18n.java
@@ -36,6 +36,9 @@ public class I18n {
         }
         try {
             currentLanguage = LanguageSeeker.seek(languageCode);
+            if (currentLanguage == null){
+                currentLanguage = Language.Default.INSTANCE;
+            }
         } catch (IOException e) {
             // Fallback to the default language if the specified language is not found
             currentLanguage = Language.Default.INSTANCE;
diff --git a/src/main/java/net/minecraft/core/lang/LanguageSeeker.java b/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
index 2aa4da8d7..73cf25313 100644
--- a/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
+++ b/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
@@ -5,6 +5,8 @@ import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonElement;
 import com.b100.json.element.JsonObject;
 import net.minecraft.core.Global;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 import java.nio.charset.StandardCharsets;
@@ -28,6 +30,7 @@ public class LanguageSeeker {
      * @return the language found, or <tt>null</tt> if no language with the specific ID is found
      * @throws IOException if an I/O error has occured
      */
+    @Nullable
     public static Language seek(String id) throws IOException {
         if (id.equals("en_US")) return Language.Default.INSTANCE;
         Language ret = null;
diff --git a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
index e2a5e248a..9063c475a 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
@@ -3,6 +3,7 @@ package net.minecraft.core.net.command;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class ClientCommandHandler implements CommandHandler{
 
@@ -27,7 +28,7 @@ public class ClientCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public EntityPlayer getPlayer(String name) {
+	public @Nullable EntityPlayer getPlayer(String name) {
 		if(minecraft.thePlayer.username.equalsIgnoreCase(name)) {
 			return minecraft.thePlayer;
 		}else {
diff --git a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
index 95214f844..91b3c525a 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
@@ -2,6 +2,7 @@ package net.minecraft.core.net.command;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.world.World;
 import net.minecraft.client.entity.player.EntityPlayerSP;
 
 public class ClientPlayerCommandSender extends PlayerCommandSender{
@@ -35,5 +36,10 @@ public class ClientPlayerCommandSender extends PlayerCommandSender{
 	public String getName() {
 		return player.getDisplayName();
 	}
+
+	@Override
+	public World getWorld() {
+		return minecraft.theWorld;
+	}
 	
 }
diff --git a/src/main/java/net/minecraft/core/net/command/CommandHandler.java b/src/main/java/net/minecraft/core/net/command/CommandHandler.java
index d79983558..f6a3b30c9 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandHandler.java
@@ -2,44 +2,45 @@ package net.minecraft.core.net.command;
 
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public interface CommandHandler {
 	
 	/**
 	 * Sends command feedback to the player who sent the command, and to all admins
 	 */
-	public void sendCommandFeedback(CommandSender sender, String message);
+    void sendCommandFeedback(CommandSender sender, String message);
 	
-	public void sendMessageToAdmins(String msg);
+	void sendMessageToAdmins(String msg);
 	
-	public void sendMessageToAllPlayers(String msg);
+	void sendMessageToAllPlayers(String msg);
 	
-	public void sendMessageToPlayer(EntityPlayer player, String messsage);
-	
-	public EntityPlayer getPlayer(String name);
+	void sendMessageToPlayer(EntityPlayer player, String messsage);
+
+	@Nullable EntityPlayer getPlayer(String name);
 	
-	public boolean playerExists(String name);
+	boolean playerExists(String name);
 	
-	public World getWorld(int dimension);
+	World getWorld(int dimension);
 
 	
-	public default World getWorld(EntityPlayer player) {
+	default World getWorld(EntityPlayer player) {
 		return getWorld(player.dimension);
 	}
 	
-	public default boolean isServer() {
+	default boolean isServer() {
 		return this instanceof ServerCommandHandler;
 	}
 	
-	public default boolean isClient() {
+	default boolean isClient() {
 		return this instanceof ClientCommandHandler;
 	}
 	
-	public default ServerCommandHandler asServer() {
+	default ServerCommandHandler asServer() {
 		return (ServerCommandHandler) this;
 	}
 	
-	public default ClientCommandHandler asClient() {
+	default ClientCommandHandler asClient() {
 		return (ClientCommandHandler) this;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/CommandSender.java b/src/main/java/net/minecraft/core/net/command/CommandSender.java
index 489603394..f91de575f 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandSender.java
@@ -1,12 +1,15 @@
 package net.minecraft.core.net.command;
 
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.world.World;
 
 public interface CommandSender {
 	
 	public boolean isAdmin();
 	
 	public EntityPlayer getPlayer();
+	
+	public World getWorld();
 
 	public void sendMessage(String string);
 	
diff --git a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
index fff12b7e9..98695cb71 100644
--- a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
@@ -1,13 +1,11 @@
 package net.minecraft.core.net.command;
 
+import org.apache.log4j.Logger;
 
-
-import net.minecraft.client.Minecraft;
-import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.util.helper.LogPrintStream;
-import org.apache.log4j.Logger;
-
+import net.minecraft.core.world.World;
+import net.minecraft.server.MinecraftServer;
 
 public class ConsoleCommandSender implements CommandSender{
 	
@@ -39,5 +37,10 @@ public class ConsoleCommandSender implements CommandSender{
 		return "Console";
 	}
 
+	@Override
+	public World getWorld() {
+		return minecraftServer.getDimensionWorld(0);
+	}
+
 
 }
diff --git a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
index 0df5d99cf..27a177b64 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
@@ -5,6 +5,7 @@ import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.net.packet.Packet3Chat;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class ServerCommandHandler implements CommandHandler{
 
@@ -20,7 +21,7 @@ public class ServerCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public EntityPlayer getPlayer(String name) {
+	public @Nullable EntityPlayer getPlayer(String name) {
 		return minecraftServer.playerList.getPlayerEntity(name);
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
index 4c58d5cb0..eea4757e6 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net.command;
 
 import net.minecraft.core.util.helper.AES;
+import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.server.entity.player.EntityPlayerMP;
@@ -40,4 +41,9 @@ public class ServerPlayerCommandSender extends PlayerCommandSender{
 		return player.getDisplayName();
 	}
 
+	@Override
+	public World getWorld() {
+		return player.world;
+	}
+
 }
diff --git a/src/main/java/net/minecraft/core/net/command/TextFormatting.java b/src/main/java/net/minecraft/core/net/command/TextFormatting.java
index 5d91c01e3..c953a03c7 100644
--- a/src/main/java/net/minecraft/core/net/command/TextFormatting.java
+++ b/src/main/java/net/minecraft/core/net/command/TextFormatting.java
@@ -25,7 +25,7 @@ public class TextFormatting {
     public static final TextFormatting UNDERLINE = new TextFormatting(19).setNames("Underline");
     public static final TextFormatting ITALIC = new TextFormatting(20).setNames("Italic");
     public static final TextFormatting RESET = new TextFormatting(21).setNames("Reset");
-	
+
 	public final int id;
 	public final char code;
 	private String[] names;
@@ -53,10 +53,7 @@ public class TextFormatting {
 		return null;
 	}
 	public static String removeAllFormatting(String name){
-		for (TextFormatting formatting : FORMATTINGS) {
-			name = name.replace(formatting.toString(), "");
-		}
-		return name;
+		return name.replaceAll("§[0123456789abcdefklmnor]|§<(.*?)>", "");
 	}
 
     public static String formatted(String string, TextFormatting... formattings) {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java b/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java
index bbd29854d..1bffff740 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/DeopCommand.java
@@ -18,12 +18,17 @@ public class DeopCommand extends ServerCommand{
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
 		if(args.length == 0) return false;
 		String name = args[0];
-		
+
+		boolean playerWasOp = server.playerList.isOp(name);
+
 		server.playerList.deopPlayer(name);
-		handler.sendCommandFeedback(sender, "De-opping "+name);
+
+		if (playerWasOp) {
+			handler.sendCommandFeedback(sender, "De-opping "+name);
+		}
 
 		EntityPlayerMP player = (EntityPlayerMP) handler.getPlayer(name);
-		if(player != null) {
+		if(player != null && playerWasOp) {
 			handler.sendMessageToPlayer(player, TextFormatting.YELLOW + "You are no longer op!");
 			player.mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
 		}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java b/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java
index 55c278caa..acee986f0 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/NicknameCommand.java
@@ -28,7 +28,8 @@ public class NicknameCommand extends ServerCommand
             StringBuilder enteredNicknameStr = new StringBuilder();
             for (int i = 1; i < args.length; i++) enteredNicknameStr.append(args[i]).append(" ");
 
-            String enteredNickname = enteredNicknameStr.substring(0, enteredNicknameStr.length() - 1);
+            String enteredNickname = TextFormatting.removeAllFormatting(enteredNicknameStr.substring(0, enteredNicknameStr.length() - 1));
+            System.out.println(enteredNickname);
             if (enteredNickname.length() > 16) enteredNickname = enteredNickname.substring(0, 16);
 
             player.nickname = enteredNickname;
@@ -67,7 +68,8 @@ public class NicknameCommand extends ServerCommand
                 StringBuilder enteredNicknameStr = new StringBuilder();
                 for (int i = 2; i < args.length; i++) enteredNicknameStr.append(args[i]).append(" ");
 
-                String enteredNickname = enteredNicknameStr.substring(0, enteredNicknameStr.length() - 1);
+                String enteredNickname = TextFormatting.removeAllFormatting(enteredNicknameStr.substring(0, enteredNicknameStr.length() - 1));
+                System.out.println(enteredNickname);
                 if (enteredNickname.length() > 16) enteredNickname = enteredNickname.substring(0, 16);
 
                 player.nickname = enteredNickname;
